Sketcher SketchObject

From FreeCAD Documentation
Jump to navigation Jump to search
Other languages:
Deutsch • ‎English • ‎français • ‎italiano • ‎polski • ‎русский

Introduction

Sketcher Sketch.svg

A Sketcher SketchObject, or formally a Sketcher::SketchObject, is the base element to create 2D objects with the Sketcher Workbench.

The Sketcher::SketchObject is derived from the Part Part2DObject, which means it is a Part Feature object specialized for 2D geometry. Like the Part2DObject, the SketchObject can be attached to planes and faces. In addition, the SketchObject can handle geometrical constraints.

FreeCAD core objects.svg

Simplified diagram of the relationships between the core objects in FreeCAD

Usage

  1. Switch to the Sketcher Workbench.
  2. Press Sketcher NewSketch.svg Sketcher NewSketch.
  3. Select a Sketch orientation: XY-plane, XZ-plane, or YZ-plane. Optionally also choose Reverse direction, and give an Offset value.
  4. Press OK.

Although the SketchObject can be used by itself to draw on a plane, it is most commonly used in conjunction with the PartDesign Workbench to create extruded solids.

  1. Switch to the PartDesign Workbench.
  2. Press PartDesign Body.svg PartDesign Body.
  3. Press PartDesign NewSketch.svg PartDesign NewSketch.
  4. Select feature: XY_Plane (Base plane), XZ_Plane (Base plane), or YZ_Plane (Base plane).
  5. Press OK.

Properties

See Property for all property types that scripted objects can have.

The Sketcher SketchObject (Sketcher::SketchObject class) is derived from the Part Part2DObject (Part::Part2DObject class) and inherits all its properties.

The Sketcher SketchObject also has the following additional properties in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Data

Sketch

  • Data (Hidden)Geometry (GeometryList): a list of Part geometries that exist inside the sketch.
  • DataConstraints: named constraints, if they exist; otherwise it is an empty list [].
  • DataExternal Geometry (LinkSubList): a list of Part geometries outside this Sketch that are used for reference.
  • Data (Hidden)Fully Constrained (Bool): (read-only) if true the sketch is fully constrained.

View

Auto Constraints

  • ViewAutoconstraints (Bool): if true constraints are automatically added when geometry is drawn.
  • ViewAvoid Redundant (Bool): if true redundant auto-constraints are avoided.

Grid

  • View (Hidden)Grid Auto Size (Bool): if true the grid is resized based on the boundingbox of the geometry of the sketch.
  • ViewGrid Size (Length): the size of the spacing of the local grid lines in the 3D view; it defaults to 10 mm.
  • ViewGrid Snap (Bool): if true the grid can be used to snap points.
  • ViewGrid Style (Enumeration): the style of the grid lines; Dashed (default) or Light.
  • ViewShow Grid (Bool): if true a grid local to the object will be displayed in the 3D view. This grid is independent of the Draft Grid.
  • ViewShow Only In Edit Mode (Bool): if true the grid is only displayed while the sketch is being edited.
  • ViewTight Grid (Bool): if true the local grid will be localized around the origin of the shape, otherwise it will extend itself more.
  • Viewmax Number Of Lines (Integer): the maximum number of lines in the grid.

Visibility automation

  • ViewEditing Workbench (String): name of the workbench to activate when editing the sketch; it defaults to SketcherWorkbench.
  • ViewForce Ortho (Bool): if true the camera will be forced to orthographic view mode when the sketch is opened.
  • ViewHide Dependent (Bool): if true all objects that depend on the sketch are hidden when the sketch is opened.
  • ViewRestore Camera (Bool): if true the camera position is saved before opening the sketch, and is restored after closing it.
  • ViewSection View (Bool): if true only (parts of) objects behind the sketch plane are visible while the sketch is being edited.
  • ViewShow Links (Bool): if true all objects used in links to external geometry are shown when the sketch is opened.
  • ViewShow Support (Bool): if true all objects this sketch is attached to are shown when the sketch is opened.
  • View (Hidden)Tempo Vis (PythonObject): a custom class associated with this object, that handles hiding and showing other objects when opening and closing the sketch.

Scripting

See also: FreeCAD Scripting Basics and scripted objects.

See Part Feature for the general information on adding objects to the document.

A SketchObject is created with the addObject() method of the document.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObject", "Sketch")
obj.Label = "Custom label"

For Python subclassing you should create the Sketcher::SketchObjectPython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObjectPython", "CustomSketch")
obj.Label = "Custom label"